## fckit 0.12.0

=== CMakeLists.txt ===
# (C) Copyright 2013 ECMWF.
#
# This software is licensed under the terms of the Apache Licence Version 2.0
# which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
# In applying this licence, ECMWF does not waive the privileges and immunities
# granted to it by virtue of its status as an intergovernmental organisation nor
# does it submit to any jurisdiction.

############################################################################################
# FCKIT

cmake_minimum_required( VERSION 3.12 FATAL_ERROR )

find_package( ecbuild 3.4 REQUIRED HINTS ${CMAKE_CURRENT_SOURCE_DIR} ${CMAKE_CURRENT_SOURCE_DIR}/../ecbuild )

project( fckit LANGUAGES C CXX Fortran )

set(CMAKE_DIRECTORY_LABELS "fckit")
set(CMAKE_CXX_STANDARD 17)
set(CMAKE_CXX_STANDARD_REQUIRED ON)

################################################################################################
# options & dependencies

ecbuild_find_python( VERSION 3.4 REQUIRED NO_LIBS )

### Fortran ...
ecbuild_enable_fortran( REQUIRED MODULE_DIRECTORY ${PROJECT_BINARY_DIR}/module )

ecbuild_check_fortran( FEATURES finalization )

set( FEATURE_FINAL_DEFAULT ON )
set( PGIBUG_ATLAS_197 0 )
if( CMAKE_Fortran_COMPILER_ID MATCHES "PGI|NVHPC" )
  if( ${CMAKE_Fortran_COMPILER_VERSION} VERSION_LESS 19.4 )
      set( PGIBUG_ATLAS_197 1 )
  endif()
  if( ${CMAKE_Fortran_COMPILER_VERSION} VERSION_LESS 19.10 )
    # Compilation works, but runtime segmentation faults occur (tested with pgi/17.7)
    set( FEATURE_FINAL_DEFAULT OFF )
  else()
    list( APPEND FCKIT_QUARANTAINED_TESTS fckit_test_shared_ptr )
    # deallocation of list of shared_ptr only seems to deallocate first entry
  endif()
endif()
if( CMAKE_Fortran_COMPILER_ID STREQUAL "Intel" )
  # known to work: 2021.4.0.20210910  from intel/2021.4
  # known to fail: 2021.10.0.20230609 from intel/2023.2
  #    -->   deallocation of list of shared_ptr only seems to deallocate first entry
  if( CMAKE_Fortran_COPMPILER_VERSION VERSION_GREATER 2021.4 ) 
    list( APPEND FCKIT_QUARANTAINED_TESTS fckit_test_shared_ptr )
  endif()
endif()

ecbuild_add_option( FEATURE FINAL
                    DESCRIPTION "Enable automatic finalisation for derived types (destructors)"
                    DEFAULT ${FEATURE_FINAL_DEFAULT}
                    CONDITION EC_HAVE_Fortran_FINALIZATION )

if( fckit_HAVE_FINAL )
    include( final-support )
    check_final_support()
    ecbuild_info( "FCKIT_HAVE_FINAL [1]")
    ecbuild_info( "  FCKIT_FINAL_FUNCTION_RESULT              = ${FCKIT_FINAL_FUNCTION_RESULT}")
    ecbuild_info( "  FCKIT_FINAL_UNINITIALIZED_LOCAL          = ${FCKIT_FINAL_UNINITIALIZED_LOCAL}")
    ecbuild_info( "  FCKIT_FINAL_UNINITIALIZED_INTENT_OUT     = ${FCKIT_FINAL_UNINITIALIZED_INTENT_OUT}")
    ecbuild_info( "  FCKIT_FINAL_UNINITIALIZED_INTENT_INOUT   = ${FCKIT_FINAL_UNINITIALIZED_INTENT_INOUT}")
    ecbuild_info( "  FCKIT_FINAL_NOT_PROPAGATING              = ${FCKIT_FINAL_NOT_PROPAGATING}")
    ecbuild_info( "  FCKIT_FINAL_NOT_INHERITING               = ${FCKIT_FINAL_NOT_INHERITING}")
    ecbuild_info( "  FCKIT_FINAL_BROKEN_FOR_ALLOCATABLE_ARRAY = ${FCKIT_FINAL_BROKEN_FOR_ALLOCATABLE_ARRAY}")
    ecbuild_info( "  FCKIT_FINAL_BROKEN_FOR_AUTOMATIC_ARRAY   = ${FCKIT_FINAL_BROKEN_FOR_AUTOMATIC_ARRAY}")
endif()
if( NOT fckit_HAVE_FINAL )
    ecbuild_info( "fckit_HAVE_FINAL [0]")
    set( FCKIT_FINAL_FUNCTION_RESULT              0 )
    set( FCKIT_FINAL_UNINITIALIZED_LOCAL          0 )
    set( FCKIT_FINAL_UNINITIALIZED_INTENT_OUT     0 )
    set( FCKIT_FINAL_UNINITIALIZED_INTENT_INOUT   0 )
    set( FCKIT_FINAL_NOT_PROPAGATING              0 )
    set( FCKIT_FINAL_NOT_INHERITING               0 )
    set( FCKIT_FINAL_BROKEN_FOR_ALLOCATABLE_ARRAY 0 )
    set( FCKIT_FINAL_BROKEN_FOR_AUTOMATIC_ARRAY   0 )
endif()

ecbuild_find_package( NAME eckit VERSION 1.14 QUIET )
ecbuild_add_option( FEATURE ECKIT
                    DESCRIPTION "Wrap ecKit functionality"
                    CONDITION eckit_FOUND )
if( NOT fckit_HAVE_ECKIT )
    ecbuild_warn("ecKit could not be found. This disables various fckit features such as MPI, Configuration, Logging")
endif()

## MPI
set( fckit_HAVE_ECKIT_MPI_PARALLEL 0 )
if( fckit_HAVE_ECKIT )
  if( eckit_HAVE_MPI OR ECKIT_HAVE_MPI )
    set( fckit_HAVE_ECKIT_MPI_PARALLEL 1 )
    set( HAVE_MPI 1 )
  else()
    set( fckit_HAVE_ECKIT_MPI_PARALLEL 0 )
    set( HAVE_MPI 0 )
  endif()
endif()
set( fckit_HAVE_MPI ${HAVE_MPI} )
if( fckit_HAVE_ECKIT )
  if( NOT fckit_HAVE_MPI )
    ecbuild_warn("ecKit has been compiled without MPI. This causes fckit to not be able to run parallel executables.")
  else()
    ecbuild_info("ecKit has been compiled with MPI")
  endif()
endif()

################################################################################################
# export package info

set( FCKIT_LIBRARIES  fckit )

################################################################################################
# find fypp

find_program(FYPP fypp)
if( FYPP )
  ecbuild_info("fckit found fypp: ${FYPP}")
endif()

# sources

if( NOT FYPP )
  set( FYPP ${CMAKE_CURRENT_SOURCE_DIR}/tools/fckit-eval.sh ${PYTHON_EXECUTABLE} ${CMAKE_CURRENT_SOURCE_DIR}/tools/fckit-fypp.py )
endif()
set( FCTEST_GENERATOR ${PYTHON_EXECUTABLE} ${CMAKE_CURRENT_SOURCE_DIR}/tools/fctest-generate-runner.py )
include( fckit_preprocess_fypp )
include( add_fctest )

add_subdirectory( src )
add_subdirectory( doc )

################################################################################################
# finalize

ecbuild_print_summary()
################################################################################################

if( ECBUILD_INSTALL_FORTRAN_MODULES )
    install( DIRECTORY ${CMAKE_Fortran_MODULE_DIRECTORY}/${CMAKE_CFG_INTDIR}
             DESTINATION module/fckit
             COMPONENT modules )
endif()
if( NOT PROJECT_NAME STREQUAL CMAKE_PROJECT_NAME )
  set( FCTEST_GENERATOR ${FCTEST_GENERATOR} PARENT_SCOPE )
  if( NOT FYPP )
    set( FYPP ${FYPP} PARENT_SCOPE )
  endif()
endif()
file(READ ${CMAKE_CURRENT_SOURCE_DIR}/cmake/add_fctest.cmake ADD_FCTEST)
file(READ ${CMAKE_CURRENT_SOURCE_DIR}/cmake/fckit_preprocess_fypp.cmake FCKIT_PREPROCESS_FYPP )

set( install_permissions OWNER_READ OWNER_WRITE OWNER_EXECUTE GROUP_READ GROUP_EXECUTE WORLD_READ WORLD_EXECUTE )
install( FILES tools/fctest-generate-runner.py DESTINATION libexec PERMISSIONS ${install_permissions} )
install( FILES tools/fckit-eval.sh DESTINATION libexec PERMISSIONS ${install_permissions} )
install( FILES contrib/fypp-3.2-b8dd58b-20230822/bin/fypp DESTINATION libexec RENAME fckit-fypp.py PERMISSIONS ${install_permissions} )

ecbuild_install_project( NAME fckit )

=== doc/CMakeLists.txt ===
# (C) Copyright 2013 ECMWF.
#
# This software is licensed under the terms of the Apache Licence Version 2.0
# which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
# In applying this licence, ECMWF does not waive the privileges and immunities
# granted to it by virtue of its status as an intergovernmental organisation nor
# does it submit to any jurisdiction.

find_package(FORD QUIET)
ecbuild_add_option(
  FEATURE DOCS
  DESCRIPTION "Generate reference documentation"
  CONDITION FORD_FOUND )

if( HAVE_DOCS )

  set( FCKIT_DOC fckit_doc )
  if( PROJECT_NAME STREQUAL CMAKE_PROJECT_NAME )
    set( FCKIT_DOC doc )
  endif()

  set( FORDFILE ford.md CACHE INTERNAL "FORD project filename" )
  set( FORDPREPROCESSOR ford-preprocessor )
  configure_file(${CMAKE_CURRENT_SOURCE_DIR}/${FORDFILE}.in "${CMAKE_CURRENT_BINARY_DIR}/${FORDFILE}" @ONLY )
  configure_file(${CMAKE_CURRENT_SOURCE_DIR}/${FORDPREPROCESSOR}.in "${CMAKE_CURRENT_BINARY_DIR}/${FORDPREPROCESSOR}" @ONLY )

  file( GLOB_RECURSE FORD_DEPENDS ${PROJECT_SOURCE_DIR}/src/fckit/* )
  list( APPEND FORD_DEPENDS ${CMAKE_CURRENT_SOURCE_DIR}/${FORDFILE}.in ${CMAKE_CURRENT_SOURCE_DIR}/${FORDPREPROCESSOR}.in )

  add_custom_command(OUTPUT "ford/index.html"
    COMMAND ${FORD_EXECUTABLE} --debug "${CMAKE_CURRENT_BINARY_DIR}/${FORDFILE}"
    WORKING_DIRECTORY "${CMAKE_CURRENT_BINARY_DIR}"
    DEPENDS ${FORD_DEPENDS}
    COMMENT "Building HTML documentation for ${CMAKE_PROJECT_NAME} using FORD (${CMAKE_CURRENT_BINARY_DIR}/ford/index.html)" )
  add_custom_target( ${FCKIT_DOC} DEPENDS "ford/index.html" ${FORD_DEPENDS} )

endif()

=== src/fckit/CMakeLists.txt ===
# (C) Copyright 2013 ECMWF.
#
# This software is licensed under the terms of the Apache Licence Version 2.0
# which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
# In applying this licence, ECMWF does not waive the privileges and immunities
# granted to it by virtue of its status as an intergovernmental organisation nor
# does it submit to any jurisdiction.

if( HAVE_ECKIT )
  list( APPEND eckit_required_src
      module/fckit.F90
      module/fckit_pathname.F90
      module/fckit_configuration.F90
      module/fckit_configuration.cc
      module/fckit_mpi.cc
      module/fckit_mpi.fypp
      module/fckit_main.cc
      module/fckit_main.F90
      module/fckit_exception.F90
      module/fckit_signal.F90
      module/fckit_resource.cc
      module/fckit_resource.F90
      module/fckit_log.cc
      module/fckit_log.F90
      module/fckit_buffer.cc
      module/fckit_buffer.F90
      module/fckit_owned.cc
      module/fckit_owned_object.F90
      module/fckit_map.cc
      module/fckit_map.F90
      Libfckit.h
      Libfckit.cc
      Main.h
      Main.cc
      Log.h
      Log.cc
  )
  if( FCKIT_HAVE_ECKIT_TENSOR )
    list( APPEND eckit_required_src
      module/fckit_tensor.cc
      module/fckit_tensor.F90
    )
  endif()
  set( eckit_required_libs eckit eckit_mpi )
endif()

configure_file(fckit.h.in  fckit.h)
install( FILES ${CMAKE_CURRENT_BINARY_DIR}/fckit.h DESTINATION include/fckit )
set( source_files_properties fckit.h.in PROPERTIES HEADER_FILE_ONLY TRUE )


if( BUILD_SHARED_LIBS )
    set( fckit_type SHARED )
else()
    set( fckit_type STATIC )
endif()

if( CMAKE_Fortran_COMPILER_ID MATCHES "PGI|NVHPC" )
  # Bug tested with pgi/17.7 (fixed pgi/19.4) requires fckit to be compiled statically
  if( ${CMAKE_Fortran_COMPILER_VERSION} VERSION_LESS 18.7 )
      ecbuild_warn( "Bug in pgi < 19.4 requires fckit to be compiled statically" )
      set( fckit_type STATIC )
  endif()

  # Turn off all compiler warnings for reason :
  #   PGF90-W-0435-Array declared with zero size
  #      (/tmp/nawd/atlas-bundle/source/fckit/src/fckit/module/fckit_array.F90: 25)
  set_source_files_properties( module/fckit_array.F90  PROPERTIES COMPILE_FLAGS "-w" )
endif()

if( CMAKE_Fortran_COMPILER_ID MATCHES "Cray" )
  # Problem with type-bound procedures requires fckit static compilation or -fuse-ld=bfd linking flag
  # Problem is tracked with LUMI #3011 support ticket and https://jira.ecmwf.int/browse/DE-927
  # Bug present with cce/14 cce/15 cce/16 cce/17 (versions greater not tested)
  if( ${CMAKE_Fortran_COMPILER_VERSION} VERSION_GREATER_EQUAL 14 )
      ecbuild_warn( "Bug in cray < 14 requires fckit to be compiled statically" )
      set( fckit_type STATIC )
  endif()
endif()


ecbuild_add_library( 
    TARGET     fckit
    LINKER_LANGUAGE CXX
        # We need the C++ linker for the error handling to work
        # Otherwise death by recursion in function "fckit_terminate"
        # when uncaught exceptions are encountered
    SOURCES
               fctest.h
               fctest.F90
               Log.F90
               module/fckit_array.F90
               module/fckit_C_interop.cc
               module/fckit_C_interop.F90
               module/fckit_object.F90
               module/fckit_final.F90
               module/fckit_refcount.F90
               module/fckit_shared_ptr.F90
               module/fckit_shared_object.F90
               ${eckit_required_src}
    PRIVATE_INCLUDES
               ${ECKIT_INCLUDE_DIRS}
               ${CMAKE_CURRENT_BINARY_DIR}

    INSTALL_HEADERS_LIST
               fctest.h
               Log.h
               Main.h

    HEADER_DESTINATION  include/fckit

    PUBLIC_INCLUDES
        $<BUILD_INTERFACE:${PROJECT_SOURCE_DIR}/src>
        $<BUILD_INTERFACE:${PROJECT_BINARY_DIR}/src>
        $<BUILD_INTERFACE:${CMAKE_Fortran_MODULE_DIRECTORY}>
        $<INSTALL_INTERFACE:include>
        $<INSTALL_INTERFACE:module/fckit>

    PRIVATE_LIBS
       ${eckit_required_libs}

    TYPE ${fckit_type}

)

fckit_target_preprocess_fypp( fckit )

=== src/tests/CMakeLists.txt ===
# (C) Copyright 2013 ECMWF.
#
# This software is licensed under the terms of the Apache Licence Version 2.0
# which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
# In applying this licence, ECMWF does not waive the privileges and immunities
# granted to it by virtue of its status as an intergovernmental organisation nor
# does it submit to any jurisdiction.

cmake_policy( SET CMP0064 NEW ) # Recognize ``TEST`` as operator for the ``if()`` command. (introduced in CMake version 3.4)

add_fctest( TARGET  fckit_test_array
            LINKER_LANGUAGE Fortran
            SOURCES test_array.F90
            LIBS    fckit)

add_fctest( TARGET  fckit_test_resource
            LINKER_LANGUAGE Fortran
            SOURCES test_resource.F90
            ARGS    -integer 10 -long 5000000000 -float 0.123456 -double 0.1234567890123456789 -string "hello world"
            CONDITION HAVE_ECKIT
            LIBS    fckit)

add_fctest( TARGET  fckit_test_log
            LINKER_LANGUAGE Fortran
            SOURCES test_log.F90
            CONDITION HAVE_ECKIT
            LIBS    fckit)

add_fctest( TARGET  fckit_test_shared_ptr
            LINKER_LANGUAGE Fortran
            SOURCES
              test_shared_ptr.F90
              test_shared_ptr.cc
            LIBS    fckit)

add_fctest( TARGET  fckit_test_owned_object
            LINKER_LANGUAGE Fortran
            SOURCES
              test_owned_object.F90
              test_owned_object.cc
            LIBS    fckit eckit
            CONDITION HAVE_ECKIT
          )

add_fctest( TARGET  fckit_test_mpi
            LINKER_LANGUAGE Fortran
            SOURCES test_mpi.F90
            MPI 4
            CONDITION HAVE_MPI
            LIBS    fckit)

add_fctest( TARGET  fckit_test_abort
            LINKER_LANGUAGE Fortran
            SOURCES test_abort.F90
            CONDITION HAVE_ECKIT
            LIBS    fckit)

add_fctest( TARGET  fckit_test_map
            LINKER_LANGUAGE Fortran
            SOURCES test_map.F90
            CONDITION FCKIT_HAVE_ECKIT_TENSOR
            LIBS    fckit)            

add_fctest( TARGET  fckit_test_tensor
            LINKER_LANGUAGE Fortran
            SOURCES 
              test_tensor.F90
              test_tensor.cc
            INCLUDES ${ECKIT_INCLUDE_DIRS}
            CONDITION FCKIT_HAVE_ECKIT_TENSOR
            LIBS  eckit fckit)            


add_fctest( TARGET  fckit_test_configuration
            LINKER_LANGUAGE Fortran
            SOURCES test_configuration.F90
            CONDITION HAVE_ECKIT
            LIBS    fckit)
if( TEST fckit_test_configuration )
  if( NOT CMAKE_VERSION VERSION_LESS 3.15 ) # support for COMPILE_LANG_AND_ID generator expression
    target_compile_options( fckit_test_configuration PRIVATE $<$<COMPILE_LANG_AND_ID:Fortran,GNU>:-Wno-uninitialized> )
  endif()
endif()

add_fctest( TARGET  fckit_test_configuration_fails
            LINKER_LANGUAGE Fortran
            SOURCES test_configuration_fails.F90
            CONDITION HAVE_ECKIT
            LIBS    fckit)
if( TEST fckit_test_configuration_fails )
    set_tests_properties( fckit_test_configuration_fails PROPERTIES
        PASS_REGULAR_EXPRESSION "Could not find \"missing\" in Configuration"
        TIMEOUT 20 )
endif()

add_fctest( TARGET  fckit_test_broadcast_file
            LINKER_LANGUAGE Fortran
            SOURCES test_broadcast_file.F90
            MPI 4
            CONDITION HAVE_MPI
            LIBS    fckit)

add_fctest( TARGET fckit_test_fypp
  LINKER_LANGUAGE Fortran
  SOURCES test_fypp.fypp
  LIBS fckit
)

ecbuild_add_test( TARGET  fckit_test_configuration_cpp
            LINKER_LANGUAGE Fortran
            SOURCES
            test_configuration.cc
            test_configuration_fortcode.F90
            INCLUDES ${ECKIT_INCLUDE_DIRS}
            CONDITION HAVE_ECKIT
            LIBS    fckit  eckit eckit_mpi )

if( TEST fckit_test_configuration_cpp )
  set_property( TEST fckit_test_configuration_cpp APPEND PROPERTY LABELS "fortran" )
endif()

ecbuild_add_test( TARGET fckit_test_cpp
  LINKER_LANGUAGE Fortran
  SOURCES test_cpp.cc test_cpp_fortcode.F90
  INCLUDES ${ECKIT_INCLUDE_DIRS}
  ENVIRONMENT "DEBUG=1"
  CONDITION HAVE_ECKIT
  LIBS fckit eckit eckit_mpi )

### Fix linking for C++ test executables linked with Fortran linker
if( CMAKE_Fortran_COMPILER_ID MATCHES "PGI|NVHPC" )
  set( NO_MAIN "-Mnomain" )
elseif( CMAKE_Fortran_COMPILER_ID MATCHES "Intel" )
  set( NO_MAIN "-nofor-main" )
elseif( CMAKE_Fortran_COMPILER_ID MATCHES "Fujitsu" )
  set( NO_MAIN "-mlcmain=main" )
endif()
if( NO_MAIN )
  foreach( _test fckit_test_configuration_cpp fckit_test_cpp )
    if( TEST ${_test} )
      set_target_properties(${_test} PROPERTIES LINK_FLAGS ${NO_MAIN} )
    endif()
  endforeach()
endif()

### Quarantaine tests if requested
foreach( _test ${FCKIT_QUARANTAINED_TESTS} )
    if( TEST ${_test} )
      set_tests_properties( ${_test} PROPERTIES DISABLED 1 )
      ecbuild_warn("Test ${_test} is quarantained (shows as not run)")
    endif()
endforeach()

### Test downstream find_package(fckit) projects
add_subdirectory( test_downstream_fypp )
add_subdirectory( test_downstream_fctest )

=== src/tests/test_downstream_fctest/CMakeLists.txt ===

# This test builds a package that requires fypp processing
# It uses the overriding of compile flags, like IFS is using.
#
# Test created to avoid regression after fixing issue FCKIT-19,
# where compile flags were not propagated to fypp-generated files.

if( HAVE_TESTS )
    
  configure_file( test-downstream.sh.in ${CMAKE_CURRENT_BINARY_DIR}/test-downstream.sh @ONLY )

  unset( _test_args )
  if( CMAKE_TOOLCHAIN_FILE )
    if( NOT IS_ABSOLUTE ${CMAKE_TOOLCHAIN_FILE})
        set( CMAKE_TOOLCHAIN_FILE "${CMAKE_BINARY_DIR}/${CMAKE_TOOLCHAIN_FILE}" )
    endif()
    list( APPEND _test_args "-DCMAKE_TOOLCHAIN_FILE=${CMAKE_TOOLCHAIN_FILE}" )
  endif()
  foreach( lang C CXX Fortran )
    if( CMAKE_${lang}_COMPILER )
      list( APPEND _test_args "-DCMAKE_${lang}_COMPILER=${CMAKE_${lang}_COMPILER}" )
    endif()
  endforeach()

  add_test( NAME fckit_test_downstream_fctest
            COMMAND ${CMAKE_CURRENT_BINARY_DIR}/test-downstream.sh ${_test_args} )

endif()

=== src/tests/test_downstream_fypp/CMakeLists.txt ===

# This test builds a package that requires fypp processing
# It uses the overriding of compile flags, like IFS is using.
#
# Test created to avoid regression after fixing issue FCKIT-19,
# where compile flags were not propagated to fypp-generated files.

if( HAVE_TESTS AND HAVE_ECKIT )

  configure_file( test-downstream.sh.in ${CMAKE_CURRENT_BINARY_DIR}/test-downstream.sh @ONLY )

  unset( _test_args )
  if( CMAKE_TOOLCHAIN_FILE )
    if( NOT IS_ABSOLUTE ${CMAKE_TOOLCHAIN_FILE})
      set( CMAKE_TOOLCHAIN_FILE "${CMAKE_BINARY_DIR}/${CMAKE_TOOLCHAIN_FILE}" )
    endif()
    list( APPEND _test_args "-DCMAKE_TOOLCHAIN_FILE=${CMAKE_TOOLCHAIN_FILE}" )
  endif()
  foreach( lang C CXX Fortran )
    if( CMAKE_${lang}_COMPILER )
      list( APPEND _test_args "-DCMAKE_${lang}_COMPILER=${CMAKE_${lang}_COMPILER}" )
    endif()
  endforeach()

  add_test( NAME fckit_test_downstream_fypp
            COMMAND ${CMAKE_CURRENT_BINARY_DIR}/test-downstream.sh ${_test_args} )

endif()

=== debian/changelog ===
fckit (0.12.0-1build1) noble; urgency=medium

  * No-change rebuild for CVE-2024-3094

 -- Steve Langasek <steve.langasek@ubuntu.com>  Sun, 31 Mar 2024 00:58:11 +0000

fckit (0.12.0-1) unstable; urgency=medium

  * New upstream release

 -- Alastair McKinstry <mckinstry@debian.org>  Sun, 24 Mar 2024 07:32:59 +0000

fckit (0.11.1-1) unstable; urgency=medium

  * New upstream release

 -- Alastair McKinstry <mckinstry@debian.org>  Thu, 29 Feb 2024 10:21:39 +0000

fckit (0.11.0-6) unstable; urgency=medium

  * Fix broken INTERFACE_INCLUDE_DIRECTORIES in fckit-import.cmake
  * Build, test (but don't install) for any compilers in FC_OPTIONAL
  * Drop empty paths.patch

 -- Alastair McKinstry <mckinstry@debian.org>  Sun, 31 Dec 2023 17:14:50 +0000

fckit (0.11.0-5) unstable; urgency=medium

  * Use fortran-support.mk 0.31; build for default fortran only
  * Revert to libddir for FMODDIR
  * Add fortran:Depends to libfckit-dev
  * libfckit-dev.install.in no longer needs changes; don't autogenerate
  * dh-sequence can't be conditional

 -- Alastair McKinstry <mckinstry@debian.org>  Sun, 31 Dec 2023 08:35:34 +0000

fckit (0.11.0-4) unstable; urgency=medium

  * Dont dep on  flang-17 on some archs until it builds there

 -- Alastair McKinstry <mckinstry@debian.org>  Thu, 14 Dec 2023 08:29:48 +0000

fckit (0.11.0-3) unstable; urgency=medium

  * Fix mod install paths

 -- Alastair McKinstry <mckinstry@debian.org>  Tue, 12 Dec 2023 10:42:46 +0000

fckit (0.11.0-2) unstable; urgency=medium

  * Build against eckit >= 1.24.6
  * Build-dep on architecture-is-64-bit rather than explicit list
  * Drop patching of 32-bit code as unused
  * Rebuild with FMODDIR in include not libdir
  * Put gfortran so files in $LIBDIR/fortran/gfortran, not versioned -13

 -- Alastair McKinstry <mckinstry@debian.org>  Sun, 10 Dec 2023 11:02:58 +0000

=== debian/control ===
Source: fckit
Section: science
Priority: optional
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Alastair McKinstry <mckinstry@debian.org>
Build-Depends: debhelper-compat (= 13), 
  architecture-is-64-bit,
  dh-sequence-fortran-mod,
  patchelf,
  ecbuild (>= 3.3.0-2),
  python3-all,
  libeckit-dev (>= 1.24.6-1~),
  libssl-dev,
  libcurl4-gnutls-dev
Standards-Version: 4.6.2
Homepage: https://github.com/ecmwf/fckit
Vcs-Browser: https://salsa.debian.org:/mckinstry/fckit.git
Vcs-Git: https://salsa.debian.org:/mckinstry/fckit.git -b debian/latest

Package: libfckit-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Depends: libfckit0d (= ${binary:Version}), ${shlib:Depends}, ${misc:Depends},
 ${fortran:Depends}, libeckit-dev
Description: Fortran toolkit for interoperating Fortran with C/C++
 This is a toolkit from ECMWF to make ecKit interoperable with Fortran.
 .
 ECMWF is the European Centre for Medium-Range Weather Forecasts.

Package: libfckit0d
Section: libs
Architecture: any
Multi-Arch: same
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: Library Fortran toolkit for interoperating Fortran with C/C++
 This is a toolkit from ECMWF to make ecKit interoperable with Fortran.
 .
 ECMWF is the European Centre for Medium-Range Weather Forecasts.

Package: libfckit-utils
Architecture: all
Depends: ${misc:Depends}, libfckit-dev, python3
Description: Library Fortran toolkit for interoperating Fortran with C/C++
 This is a toolkit from ECMWF to make ecKit interoperable with Fortran.
 .
 ECMWF is the European Centre for Medium-Range Weather Forecasts.

=== debian/rules ===
#!/usr/bin/make -f

include /usr/share/dpkg/pkg-info.mk
include /usr/share/debhelper/dh-fortran/fortran-support.mk

export FC_OPTIONAL:= 

export DH_VERBOSE=1

DEB_HOST_MULTIARCH ?= $(shell dpkg-architecture -qDEB_HOST_MULTIARCH)

TMPDIR:=$(CURDIR)/debian/tmp
LIBDIR:=/usr/lib/$(DEB_HOST_MULTIARCH)
INCDIR:=/usr/include/$(DEB_HOST_MULTIARCH)
FMODDIR:=$(shell echo $(call get_fmoddir,$(FC_DEFAULT)))
# Test suite requires 4 processors. Fake it
export OMPI_MCA_rmaps_base_oversubscribe=1

BUILD_FLAGS = 

NO_TEST_ARCH:= mips64el 
DO_TEST:= $(if $(filter $(DEB_TARGET_ARCH), $(NO_TEST_ARCH)), false, true)

%:
	dh $@ --buildsystem=ecbuild

override_dh_auto_clean:
	dh_auto_clean
	rm -rf debian/build-*

override_dh_auto_configure:
	for f in $(FC_DEFAULT) $(FC_OPTIONAL) ; do \
		dh_auto_configure --builddirectory=debian/build-$$f  -- \
			${BUILD_FLAGS} -DCMAKE_Fortran_COMPILER=$$f ; done
	#			-DCMAKE_Fortran_FLAGS="$(FLANG_FCFLAGS)"

override_dh_auto_test:
	$(DO_TEST) && (  for f in $(FC_DEFAULT) $(FC_OPTIONAL) ; do \
		dh_auto_test --builddirectory=debian/build-$$f ; \
		done )   || echo "Ignoring test failures"

override_dh_auto_build:
	for f in $(FC_DEFAULT) $(FC_OPTIONAL) ; do \
		dh_auto_build --builddirectory=debian/build-$$f ; done

override_dh_auto_install:
	dh_auto_install --builddirectory=debian/build-$(FC_DEFAULT)
	# Fixup cmake files. Hack. can we do better with patches to upstream ?
	sed -i -e 's%$${fckit_INSTALL_PREFIX}/libexec%/usr/bin%g'        	      $(TMPDIR)/$(LIBDIR)/cmake/fckit/fckit-import.cmake
	sed -i -e 's%${CURDIR}%/build/fckit/%g'     	        	      $(TMPDIR)/$(LIBDIR)/cmake/fckit/fckit-import.cmake
	sed -i -e 's%/usr/bin/python %/usr/bin/python3 %g'               	      $(TMPDIR)/$(LIBDIR)/cmake/fckit/fckit-import.cmake
	sed -i -e 's%fckit-fypp.py%fckit-fypp%' 		         	      $(TMPDIR)/$(LIBDIR)/cmake/fckit/fckit-import.cmake
	sed -i -e 's%fckit-eval.sh%fckit-eval%'                          	      $(TMPDIR)/$(LIBDIR)/cmake/fckit/fckit-import.cmake
	sed -i -e 's%fctest-generate-runner.py%fctest-generate-runner%'  	      $(TMPDIR)/$(LIBDIR)/cmake/fckit/fckit-import.cmake
	sed -i -e 's%/usr/lib/cmake%${LIBDIR}/cmake%g'  		 	      $(TMPDIR)/$(LIBDIR)/cmake/fckit/fckit-targets.cmake
	sed -i -e 's%$${_IMPORT_PREFIX}/lib/libfckit%${LIBDIR}/libfckit%g'            $(TMPDIR)/$(LIBDIR)/cmake/fckit/fckit-targets.cmake
	sed -i -e 's%$${_IMPORT_PREFIX}/include%/usr/include/${DEB_HOST_MULTIARCH}%g' $(TMPDIR)/$(LIBDIR)/cmake/fckit/fckit-targets.cmake
	sed -i -e 's%$${_IMPORT_PREFIX}/module%${FMODDIR}%g' 			      $(TMPDIR)/$(LIBDIR)/cmake/fckit/fckit-targets.cmake
	sed -i -e 's%python3\.[0-9]*%python3%g'  				      $(TMPDIR)/$(LIBDIR)/cmake/fckit/fckit-import.cmake
	# TODO: This will need work when flang is supported
	sed -i -e 's%libfckit.so.0d%libfckit-${FC_DEFAULT}.so.0d%g'			      $(TMPDIR)/$(LIBDIR)/cmake/fckit/fckit-targets-release.cmake
	# rename those with script extensions
	mv $(TMPDIR)/usr/libexec/fckit-eval.sh $(TMPDIR)/usr/libexec/fckit-eval
	mv $(TMPDIR)/usr/libexec/fckit-fypp.py $(TMPDIR)/usr/libexec/fckit-fypp
	mv $(TMPDIR)/usr/libexec/fctest-generate-runner.py $(TMPDIR)/usr/libexec/fctest-generate-runner
	chmod -x $(TMPDIR)/$(LIBDIR)/cmake/fckit/*
	mv $(TMPDIR)/$(LIBDIR)/libfckit.so.0d $(TMPDIR)/$(LIBDIR)/libfckit-${FC_DEFAULT}.so.0d
	rm $(TMPDIR)/$(LIBDIR)/libfckit.so 
	patchelf  --set-soname libfckit-gfortran.so.0d $(TMPDIR)/$(LIBDIR)/libfckit-${FC_DEFAULT}.so.0d
	patchelf  --remove-rpath $(TMPDIR)/$(LIBDIR)/libfckit-${FC_DEFAULT}.so.0d
	dh_link -p libfckit-dev $(LIBDIR)/libfckit-${FC_DEFAULT}.so.0d $(LIBDIR)/fortran/${FC_DEFAULT}/libfckit.so
	dh_link -p libfckit-dev $(LIBDIR)/libfckit-${FC_DEFAULT}.so.0d $(LIBDIR)/libfckit-${FC_DEFAULT}.so

override_dh_dwz:
	@echo "Override dwz as it breaks on shlibs edited by patchelf"

## fckit 0.13.0

=== CMakeLists.txt ===
--- 
+++ 
@@ -9,7 +9,7 @@
 ############################################################################################
 # FCKIT
 
-cmake_minimum_required( VERSION 3.12 FATAL_ERROR )
+cmake_minimum_required( VERSION 3.17 FATAL_ERROR )
 
 find_package( ecbuild 3.4 REQUIRED HINTS ${CMAKE_CURRENT_SOURCE_DIR} ${CMAKE_CURRENT_SOURCE_DIR}/../ecbuild )
 
@@ -21,8 +21,6 @@
 
 ################################################################################################
 # options & dependencies
-
-ecbuild_find_python( VERSION 3.4 REQUIRED NO_LIBS )
 
 ### Fortran ...
 ecbuild_enable_fortran( REQUIRED MODULE_DIRECTORY ${PROJECT_BINARY_DIR}/module )
@@ -116,19 +114,34 @@
 set( FCKIT_LIBRARIES  fckit )
 
 ################################################################################################
-# find fypp
+# install python venv with rumael.yaml and fypp
+include( fckit_install_venv )
+set( install_permissions OWNER_READ OWNER_WRITE OWNER_EXECUTE GROUP_READ GROUP_EXECUTE WORLD_READ WORLD_EXECUTE )
 
-find_program(FYPP fypp)
-if( FYPP )
-  ecbuild_info("fckit found fypp: ${FYPP}")
+# Discover only system install Python 3
+set( Python3_FIND_VIRTUALENV STANDARD )
+find_package( Python3 COMPONENTS Interpreter REQUIRED )
+
+ecbuild_add_option( FEATURE FCKIT_VENV
+                    DEFAULT OFF
+                    DESCRIPTION "Install Python virtual environment with fypp and a yaml parser"
+                    CONDITION Python3_VERSION VERSION_GREATER_EQUAL 3.8 )
+
+if( HAVE_FCKIT_VENV )
+   fckit_install_venv()
+else()
+   # install fypp runner script only
+   set( FYPP ${CMAKE_CURRENT_SOURCE_DIR}/tools/fckit-eval.sh
+             ${CMAKE_CURRENT_SOURCE_DIR}/contrib/fypp-3.2-b8dd58b-20230822/bin/fypp )
+
+   install( FILES contrib/fypp-3.2-b8dd58b-20230822/bin/fypp DESTINATION libexec RENAME fckit-fypp.py
+            PERMISSIONS ${install_permissions} )
 endif()
 
+################################################################################################
 # sources
 
-if( NOT FYPP )
-  set( FYPP ${CMAKE_CURRENT_SOURCE_DIR}/tools/fckit-eval.sh ${PYTHON_EXECUTABLE} ${CMAKE_CURRENT_SOURCE_DIR}/tools/fckit-fypp.py )
-endif()
-set( FCTEST_GENERATOR ${PYTHON_EXECUTABLE} ${CMAKE_CURRENT_SOURCE_DIR}/tools/fctest-generate-runner.py )
+set( FCTEST_GENERATOR ${Python3_EXECUTABLE} ${CMAKE_CURRENT_SOURCE_DIR}/tools/fctest-generate-runner.py )
 include( fckit_preprocess_fypp )
 include( add_fctest )
 
@@ -148,16 +161,12 @@
 endif()
 if( NOT PROJECT_NAME STREQUAL CMAKE_PROJECT_NAME )
   set( FCTEST_GENERATOR ${FCTEST_GENERATOR} PARENT_SCOPE )
-  if( NOT FYPP )
-    set( FYPP ${FYPP} PARENT_SCOPE )
-  endif()
+  set( FYPP ${FYPP} PARENT_SCOPE )
 endif()
 file(READ ${CMAKE_CURRENT_SOURCE_DIR}/cmake/add_fctest.cmake ADD_FCTEST)
 file(READ ${CMAKE_CURRENT_SOURCE_DIR}/cmake/fckit_preprocess_fypp.cmake FCKIT_PREPROCESS_FYPP )
 
-set( install_permissions OWNER_READ OWNER_WRITE OWNER_EXECUTE GROUP_READ GROUP_EXECUTE WORLD_READ WORLD_EXECUTE )
 install( FILES tools/fctest-generate-runner.py DESTINATION libexec PERMISSIONS ${install_permissions} )
 install( FILES tools/fckit-eval.sh DESTINATION libexec PERMISSIONS ${install_permissions} )
-install( FILES contrib/fypp-3.2-b8dd58b-20230822/bin/fypp DESTINATION libexec RENAME fckit-fypp.py PERMISSIONS ${install_permissions} )
 
 ecbuild_install_project( NAME fckit )

=== debian/changelog ===
fckit (0.13.0-1) unstable; urgency=medium

  * New upstream release
  * Fix broken vcs url
  * Standards-Version: 4.7.0; no changes required

 -- Alastair McKinstry <mckinstry@debian.org>  Fri, 14 Jun 2024 08:38:22 +0100

fckit (0.12.1-2) unstable; urgency=medium

  * Fix paths in fckit-import.cmake for tools in atlas build

 -- Alastair McKinstry <mckinstry@debian.org>  Tue, 23 Apr 2024 16:30:11 +0100

fckit (0.12.1-1) unstable; urgency=medium

  * New upstream release

 -- Alastair McKinstry <mckinstry@debian.org>  Tue, 16 Apr 2024 07:46:49 +0100

fckit (0.12.0-2) unstable; urgency=medium

  * Build against eckit 1.26.1 

 -- Alastair McKinstry <mckinstry@debian.org>  Thu, 11 Apr 2024 17:28:31 +0100

## fckit 0.13.1

=== CMakeLists.txt ===
--- 
+++ 
@@ -127,6 +127,11 @@
                     DESCRIPTION "Install Python virtual environment with fypp and a yaml parser"
                     CONDITION Python3_VERSION VERSION_GREATER_EQUAL 3.8 )
 
+ecbuild_add_option( FEATURE FCKIT_VENV_EDITABLE
+                    DEFAULT OFF
+                    DESCRIPTION "Install editable packages in fckit Python virtual environment"
+                    CONDITION HAVE_FCKIT_VENV )
+
 if( HAVE_FCKIT_VENV )
    fckit_install_venv()
 else()

=== debian/changelog ===
fckit (0.13.1-1) unstable; urgency=medium

  * New upstream release

 -- Alastair McKinstry <mckinstry@debian.org>  Sun, 22 Sep 2024 07:37:47 +0100

## fckit 0.13.3

=== CMakeLists.txt ===
--- 
+++ 
@@ -120,17 +120,17 @@
 
 # Discover only system install Python 3
 set( Python3_FIND_VIRTUALENV STANDARD )
-find_package( Python3 COMPONENTS Interpreter REQUIRED )
+find_package( Python3 COMPONENTS Interpreter )
 
 ecbuild_add_option( FEATURE FCKIT_VENV
                     DEFAULT OFF
                     DESCRIPTION "Install Python virtual environment with fypp and a yaml parser"
-                    CONDITION Python3_VERSION VERSION_GREATER_EQUAL 3.8 )
+                    CONDITION Python3_VERSION VERSION_GREATER_EQUAL 3.8 AND Python3_VERSION VERSION_LESS 3.12 )
 
-ecbuild_add_option( FEATURE FCKIT_VENV_EDITABLE
+ecbuild_add_option( FEATURE FCKIT_VENV_OFFLINE
                     DEFAULT OFF
-                    DESCRIPTION "Install editable packages in fckit Python virtual environment"
-                    CONDITION HAVE_FCKIT_VENV )
+                    DESCRIPTION "Offline install of fckit Python virtual environment"
+                    CONDITION DEFINED FCKIT_VENV_WHEEL_DIR )
 
 if( HAVE_FCKIT_VENV )
    fckit_install_venv()

=== requirements.txt ===
ruamel.yaml==0.18.6
ruamel.yaml.clib==0.2.12
setuptools==65.5.0
wheel==0.45.1

=== doc/fctest_examples/CMakeLists.txt ===
# (C) Copyright 2013 ECMWF.
#
# This software is licensed under the terms of the Apache Licence Version 2.0
# which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
# In applying this licence, ECMWF does not waive the privileges and immunities
# granted to it by virtue of its status as an intergovernmental organisation nor
# does it submit to any jurisdiction.

cmake_minimum_required( VERSION 3.12 FATAL_ERROR )

find_package( ecbuild 3.4 REQUIRED )

project( fctest_examples VERSION 0.0.0 LANGUAGES Fortran )

ecbuild_enable_fortran( REQUIRED MODULE_DIRECTORY ${PROJECT_BINARY_DIR}/module )

find_package( fckit REQUIRED )

ecbuild_add_library( TARGET fctest_example_lib
                     SOURCES fctest_example_lib.F90
                     NOINSTALL )

add_fctest( TARGET fctest_example_simple
            LINKER_LANGUAGE Fortran
            SOURCES fctest_example_simple.F90
            LIBS    fctest_example_lib )

add_fctest( TARGET fctest_example_with_fixture
            LINKER_LANGUAGE Fortran
            SOURCES fctest_example_with_fixture.F90 )

=== src/tests/test_downstream_fypp/CMakeLists.txt ===
--- 
+++ 
@@ -20,6 +20,10 @@
     if( CMAKE_${lang}_COMPILER )
       list( APPEND _test_args "-DCMAKE_${lang}_COMPILER=${CMAKE_${lang}_COMPILER}" )
     endif()
+    if( CMAKE_${lang}_FLAGS )
+      string(REPLACE "--coverage" "" CMAKE_${lang}_FLAGS "${CMAKE_${lang}_FLAGS}")
+      list( APPEND _test_args "-DCMAKE_${lang}_FLAGS=${CMAKE_${lang}_FLAGS}" )
+    endif()
   endforeach()
 
   add_test( NAME fckit_test_downstream_fypp

=== debian/changelog ===
fckit (0.13.3-1) unstable; urgency=medium

  * New upstream release

 -- Alastair McKinstry <mckinstry@debian.org>  Sat, 21 Dec 2024 08:03:12 +0000

fckit (0.13.2-1) unstable; urgency=medium

  * New upstream release

 -- Alastair McKinstry <mckinstry@debian.org>  Fri, 15 Nov 2024 09:42:36 +0000

=== debian/control ===
--- 
+++ 
@@ -1,21 +1,20 @@
 Source: fckit
 Section: science
 Priority: optional
-Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
-XSBC-Original-Maintainer: Alastair McKinstry <mckinstry@debian.org>
+Maintainer: Alastair McKinstry <mckinstry@debian.org>
 Build-Depends: debhelper-compat (= 13), 
   architecture-is-64-bit,
   dh-sequence-fortran-mod,
   patchelf,
   ecbuild (>= 3.3.0-2),
   python3-all,
-  libeckit-dev (>= 1.24.6-1~),
+  libeckit-dev (>= 1.26.1-1~),
   libssl-dev,
   libcurl4-gnutls-dev
-Standards-Version: 4.6.2
+Standards-Version: 4.7.0
 Homepage: https://github.com/ecmwf/fckit
-Vcs-Browser: https://salsa.debian.org:/mckinstry/fckit.git
-Vcs-Git: https://salsa.debian.org:/mckinstry/fckit.git -b debian/latest
+Vcs-Browser: https://salsa.debian.org/mckinstry/fckit.git
+Vcs-Git: https://salsa.debian.org/mckinstry/fckit.git -b debian/latest
 
 Package: libfckit-dev
 Section: libdevel

=== debian/watch ===
version=3
opts="uversionmangle=s/-rc/~rc/, filenamemangle=s/.+\/(\d\S+)\.tar\.gz/$1\.tar\.gz/" \
  https://github.com/ecmwf/fckit/tags .*/v?(\d\d?\d?\..+).tar\.gz

## fckit 0.13.4

=== CMakeLists.txt ===
--- 
+++ 
@@ -125,7 +125,7 @@
 ecbuild_add_option( FEATURE FCKIT_VENV
                     DEFAULT OFF
                     DESCRIPTION "Install Python virtual environment with fypp and a yaml parser"
-                    CONDITION Python3_VERSION VERSION_GREATER_EQUAL 3.8 AND Python3_VERSION VERSION_LESS 3.12 )
+                    CONDITION Python3_VERSION VERSION_GREATER_EQUAL 3.8 )
 
 ecbuild_add_option( FEATURE FCKIT_VENV_OFFLINE
                     DEFAULT OFF

=== requirements.txt ===
ruamel.yaml==0.18.6
ruamel.yaml.clib==0.2.12
setuptools==75.0.0
wheel==0.45.1

=== src/CMakeLists.txt ===
# (C) Copyright 2013 ECMWF.
#
# This software is licensed under the terms of the Apache Licence Version 2.0
# which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
# In applying this licence, ECMWF does not waive the privileges and immunities
# granted to it by virtue of its status as an intergovernmental organisation nor
# does it submit to any jurisdiction.

set(FCKIT_HAVE_ECKIT_TENSOR 0)
if( HAVE_ECKIT )
  if(eckit_VERSION VERSION_GREATER_EQUAL 1.23.0)
    set(FCKIT_HAVE_ECKIT_TENSOR 1)
  endif()
endif()

add_subdirectory(fckit)
add_subdirectory(apps)
add_subdirectory(tests)

if ( HAVE_SANDBOX )
  add_subdirectory(sandbox)
endif()

=== src/tests/test_downstream_fypp/CMakeLists.txt ===
--- 
+++ 
@@ -22,7 +22,7 @@
     endif()
     if( CMAKE_${lang}_FLAGS )
       string(REPLACE "--coverage" "" CMAKE_${lang}_FLAGS "${CMAKE_${lang}_FLAGS}")
-      list( APPEND _test_args "-DCMAKE_${lang}_FLAGS=${CMAKE_${lang}_FLAGS}" )
+      list( APPEND _test_args "-DECBUILD_${lang}_FLAGS=${CMAKE_${lang}_FLAGS}" )
     endif()
   endforeach()

=== debian/changelog ===
fckit (0.13.4-1build1) questing; urgency=medium

  * No-change rebuild for gfortran 15.

 -- Matthias Klose <doko@ubuntu.com>  Sun, 07 Sep 2025 14:27:03 +0200

fckit (0.13.4-1) unstable; urgency=medium

  * New upstream release
  * Standards-Version: 4.7.2

 -- Alastair McKinstry <mckinstry@debian.org>  Sun, 30 Mar 2025 10:09:43 +0100

=== debian/control ===
--- 
+++ 
@@ -11,7 +11,7 @@
   libeckit-dev (>= 1.26.1-1~),
   libssl-dev,
   libcurl4-gnutls-dev
-Standards-Version: 4.7.0
+Standards-Version: 4.7.2
 Homepage: https://github.com/ecmwf/fckit
 Vcs-Browser: https://salsa.debian.org/mckinstry/fckit.git
 Vcs-Git: https://salsa.debian.org/mckinstry/fckit.git -b debian/latest

## fckit 0.14.0

=== CMakeLists.txt ===
--- 
+++ 
@@ -127,11 +127,6 @@
                     DESCRIPTION "Install Python virtual environment with fypp and a yaml parser"
                     CONDITION Python3_VERSION VERSION_GREATER_EQUAL 3.8 )
 
-ecbuild_add_option( FEATURE FCKIT_VENV_OFFLINE
-                    DEFAULT OFF
-                    DESCRIPTION "Offline install of fckit Python virtual environment"
-                    CONDITION DEFINED FCKIT_VENV_WHEEL_DIR )
-
 if( HAVE_FCKIT_VENV )
    fckit_install_venv()
 else()

=== contrib/fypp-3.2-b8dd58b-20230822/docs/Makefile ===
# Minimal makefile for Sphinx documentation
#

# You can set these variables from the command line.
SPHINXOPTS    =
SPHINXBUILD   = python3 -msphinx
SPHINXPROJ    = Fypp
SOURCEDIR     = .
BUILDDIR      = _build

# Put it first so that "make" without argument is like "make help".
help:
	@$(SPHINXBUILD) -M help "$(SOURCEDIR)" "$(BUILDDIR)" $(SPHINXOPTS) $(O)

.PHONY: help Makefile

# Catch-all target: route all unknown targets to Sphinx using the new
# "make mode" option.  $(O) is meant as a shortcut for $(SPHINXOPTS).
%: Makefile
	@$(SPHINXBUILD) -M $@ "$(SOURCEDIR)" "$(BUILDDIR)" $(SPHINXOPTS) $(O)

=== contrib/fypp-3.2-b8dd58b-20230822/docs/requirements.txt ===
#
# This file is autogenerated by pip-compile with Python 3.10
# by the following command:
#
#    pip-compile requirements.in
#
alabaster==0.7.13
    # via sphinx
babel==2.12.1
    # via sphinx
certifi==2023.7.22
    # via requests
charset-normalizer==3.2.0
    # via requests
docutils==0.18.1
    # via
    #   sphinx
    #   sphinx-rtd-theme
idna==3.4
    # via requests
imagesize==1.4.1
    # via sphinx
jinja2==3.1.2
    # via sphinx
markupsafe==2.1.3
    # via jinja2
packaging==23.1
    # via sphinx
pygments==2.15.1
    # via sphinx
requests==2.31.0
    # via sphinx
snowballstemmer==2.2.0
    # via sphinx
sphinx==6.2.1
    # via
    #   -r requirements.in
    #   sphinx-rtd-theme
    #   sphinxcontrib-jquery
sphinx-rtd-theme==1.2.2
    # via -r requirements.in
sphinxcontrib-applehelp==1.0.4
    # via sphinx
sphinxcontrib-devhelp==1.0.2
    # via sphinx
sphinxcontrib-htmlhelp==2.0.1
    # via sphinx
sphinxcontrib-jquery==4.1
    # via sphinx-rtd-theme
sphinxcontrib-jsmath==1.0.1
    # via sphinx
sphinxcontrib-qthelp==1.0.3
    # via sphinx
sphinxcontrib-serializinghtml==1.1.5
    # via sphinx
urllib3==2.0.4
    # via requests

=== src/tests/test_downstream_fypp/downstream/CMakeLists.txt ===
cmake_minimum_required( VERSION 3.12 FATAL_ERROR )

find_package( ecbuild REQUIRED )

project( downstream VERSION 0.1.0 LANGUAGES Fortran)

find_package( fckit REQUIRED COMPONENTS ECKIT )


ecbuild_add_library(
    TARGET downstream
    SOURCES downstream.fypp downstream_override.fypp
    PUBLIC_LIBS fckit
    DEFINITIONS _POSIX_C_SOURCE=200809L exclude_from_fypp)
fckit_target_preprocess_fypp( downstream FYPP_ARGS_EXCLUDE "exclude_from_fypp" )

ecbuild_add_executable( TARGET main SOURCES main.F90 LIBS fckit downstream )

=== debian/changelog ===
fckit (0.14.0-3) unstable; urgency=medium

  * Rebuild for gfortran-mod-16
  * Build-dep on gfortran-15, add conflicts on gfortran-14 to ensure
    correct compiler

 -- Alastair McKinstry <mckinstry@debian.org>  Tue, 09 Sep 2025 10:55:05 +0100

fckit (0.14.0-2) unstable; urgency=medium

  * Push to unstable
  * Temporarily drop dep on ford

 -- Alastair McKinstry <mckinstry@debian.org>  Thu, 14 Aug 2025 08:43:37 +0100

fckit (0.14.0-1) experimental; urgency=medium

  * New upstream release

 -- Alastair McKinstry <mckinstry@debian.org>  Fri, 27 Jun 2025 08:46:44 +0100

fckit (0.13.4-3) experimental; urgency=medium

  * Add build-dep on ford for documentation

 -- Alastair McKinstry <mckinstry@debian.org>  Thu, 12 Jun 2025 11:25:01 +0100

fckit (0.13.4-2) experimental; urgency=medium

  * Now need eckit >= 1.29.1. Closes: #1103183

 -- Alastair McKinstry <mckinstry@debian.org>  Tue, 15 Apr 2025 11:31:00 +0100

=== debian/control ===
--- 
+++ 
@@ -5,12 +5,14 @@
 Build-Depends: debhelper-compat (= 13), 
   architecture-is-64-bit,
   dh-sequence-fortran-mod,
+  gfortran-15,
   patchelf,
   ecbuild (>= 3.3.0-2),
   python3-all,
-  libeckit-dev (>= 1.26.1-1~),
+  libeckit-dev (>= 1.29.1-1~),
   libssl-dev,
   libcurl4-gnutls-dev
+Build-Conflicts: gfortran-14
 Standards-Version: 4.7.2
 Homepage: https://github.com/ecmwf/fckit
 Vcs-Browser: https://salsa.debian.org/mckinstry/fckit.git

=== debian/rules ===
--- 
+++ 
@@ -47,7 +47,8 @@
 	dh_auto_install --builddirectory=debian/build-$(FC_DEFAULT)
 	# Fixup cmake files. Hack. can we do better with patches to upstream ?
 	sed -i -e 's%$${fckit_INSTALL_PREFIX}/libexec%/usr/bin%g'        	      $(TMPDIR)/$(LIBDIR)/cmake/fckit/fckit-import.cmake
-	sed -i -e 's%${CURDIR}%/build/fckit/%g'     	        	      $(TMPDIR)/$(LIBDIR)/cmake/fckit/fckit-import.cmake
+	sed -i -e 's%$${fckit_BASE_DIR}/libexec%/usr/bin%g'                           $(TMPDIR)/$(LIBDIR)/cmake/fckit/fckit-import.cmake
+	sed -i -e 's%${CURDIR}%/build/fckit/%g'     	        	              $(TMPDIR)/$(LIBDIR)/cmake/fckit/fckit-import.cmake
 	sed -i -e 's%/usr/bin/python %/usr/bin/python3 %g'               	      $(TMPDIR)/$(LIBDIR)/cmake/fckit/fckit-import.cmake
 	sed -i -e 's%fckit-fypp.py%fckit-fypp%' 		         	      $(TMPDIR)/$(LIBDIR)/cmake/fckit/fckit-import.cmake
 	sed -i -e 's%fckit-eval.sh%fckit-eval%'                          	      $(TMPDIR)/$(LIBDIR)/cmake/fckit/fckit-import.cmake

## fckit 0.14.1

=== CMakeLists.txt ===
--- 
+++ 
@@ -127,6 +127,11 @@
                     DESCRIPTION "Install Python virtual environment with fypp and a yaml parser"
                     CONDITION Python3_VERSION VERSION_GREATER_EQUAL 3.8 )
 
+ecbuild_add_option( FEATURE FCKIT_VENV_EDITABLE
+                    DEFAULT OFF
+                    DESCRIPTION "Install editable packages in fckit Python virtual environment"
+                    CONDITION HAVE_FCKIT_VENV )
+
 if( HAVE_FCKIT_VENV )
    fckit_install_venv()
 else()

=== src/fckit/CMakeLists.txt ===
--- 
+++ 
@@ -68,16 +68,6 @@
   set_source_files_properties( module/fckit_array.F90  PROPERTIES COMPILE_FLAGS "-w" )
 endif()
 
-if( CMAKE_Fortran_COMPILER_ID MATCHES "Cray" )
-  # Problem with type-bound procedures requires fckit static compilation or -fuse-ld=bfd linking flag
-  # Problem is tracked with LUMI #3011 support ticket and https://jira.ecmwf.int/browse/DE-927
-  # Bug present with cce/14 cce/15 cce/16 cce/17 (versions greater not tested)
-  if( ${CMAKE_Fortran_COMPILER_VERSION} VERSION_GREATER_EQUAL 14 )
-      ecbuild_warn( "Bug in cray < 14 requires fckit to be compiled statically" )
-      set( fckit_type STATIC )
-  endif()
-endif()
-
 
 ecbuild_add_library( 
     TARGET     fckit

=== src/sandbox/CMakeLists.txt ===
# (C) Copyright 2013 ECMWF.
#
# This software is licensed under the terms of the Apache Licence Version 2.0
# which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
# In applying this licence, ECMWF does not waive the privileges and immunities
# granted to it by virtue of its status as an intergovernmental organisation nor
# does it submit to any jurisdiction.

=== src/tests/CMakeLists.txt ===
--- 
+++ 
@@ -147,10 +147,16 @@
 foreach( _test ${FCKIT_QUARANTAINED_TESTS} )
     if( TEST ${_test} )
       set_tests_properties( ${_test} PROPERTIES DISABLED 1 )
-      ecbuild_warn("Test ${_test} is quarantained (shows as not run)")
+      ecbuild_warn("Test ${_test} is quarantined (shows as not run)")
     endif()
 endforeach()
 
 ### Test downstream find_package(fckit) projects
 add_subdirectory( test_downstream_fypp )
 add_subdirectory( test_downstream_fctest )
+
+### Test fckit_yaml_reader
+if( HAVE_FCKIT_VENV )
+   ecbuild_add_test( COMMAND ${CMAKE_CURRENT_SOURCE_DIR}/fckit_run_pytest.sh
+                     ARGS ${CMAKE_CURRENT_BINARY_DIR}/../.. ${CMAKE_CURRENT_SOURCE_DIR} )
+endif()

=== src/tests/test_downstream_fctest/CMakeLists.txt ===
--- 
+++ 
@@ -20,6 +20,9 @@
     if( CMAKE_${lang}_COMPILER )
       list( APPEND _test_args "-DCMAKE_${lang}_COMPILER=${CMAKE_${lang}_COMPILER}" )
     endif()
+    if( CMAKE_${lang}_FLAGS )
+      list( APPEND _test_args "-DCMAKE_${lang}_FLAGS=${CMAKE_${lang}_FLAGS}" )
+    endif()
   endforeach()
 
   add_test( NAME fckit_test_downstream_fctest

=== debian/changelog ===
fckit (0.14.1-2) unstable; urgency=medium

  * Use new dh_fortran get_fmoddir; correct output

 -- Alastair McKinstry <mckinstry@debian.org>  Thu, 13 Nov 2025 11:51:10 +0000

fckit (0.14.1-1) unstable; urgency=medium

  * New upstream release
  * Update d/watch to version 4

 -- Alastair McKinstry <mckinstry@debian.org>  Tue, 04 Nov 2025 10:01:51 +0000

=== debian/rules ===
--- 
+++ 
@@ -12,7 +12,7 @@
 TMPDIR:=$(CURDIR)/debian/tmp
 LIBDIR:=/usr/lib/$(DEB_HOST_MULTIARCH)
 INCDIR:=/usr/include/$(DEB_HOST_MULTIARCH)
-FMODDIR:=$(shell echo $(call get_fmoddir,$(FC_DEFAULT)))
+FMODDIR:=$(shell dh_fortran get_fmoddir)
 # Test suite requires 4 processors. Fake it
 export OMPI_MCA_rmaps_base_oversubscribe=1
